/****************************************************************************
 **
 ** Copyright (C) 2008-2010 Nokia Corporation and/or its subsidiary(-ies).
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
 ** This file is part of the doxygen2qthelp project on Trolltech Labs.
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 or 3.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.fsf.org/licensing/licenses/info/GPLv2.html and
 ** http://www.gnu.org/copyleft/gpl.html.
 **
 ** If you are unsure which license is appropriate for your use, please
 ** contact the sales department at qt-sales@nokia.com.
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ****************************************************************************/

#ifndef HTMLHELPDATAINTERFACE_P_H
#define HTMLHELPDATAINTERFACE_P_H

#include "qhelpdatainterface_p.h"
#include <QString>
#include <QStringList>

QT_BEGIN_NAMESPACE

class HtmlHelpParser;

class HtmlHelpDataInterface : public QHelpDataInterface
{
private:
    QString m_projectTitle;
    QString m_filterIdent;
    QString m_entryPageHref;
    QList<QHelpDataIndexItem> m_index;
    QList<QHelpDataContentItem *> m_toc;

    QString m_rootPath;
    QString m_nameSpace;
    QString m_virtualFolder;
    QStringList m_files;
    QList<QHelpDataCustomFilter> m_custumFilters;
    QList<QHelpDataFilterSection> m_filterSections;

public:
    HtmlHelpDataInterface(const QString &projectFileName,
            const QString &namespaceName, const QString &virtualFolder);

private:
    void initFromDoxygenHtmlHelpProject(const QString &projectFileName);

    const QStringList applyPrefix(const QStringList &list, const QString &prefix) const;
    QStringList findSubDirs(const QString &dir) const;
    QStringList findDoxygenFiles(const QString &dir) const;
    QStringList findDoxygenFilesRecursively(const QString &dir,
            const QString &prefix = QString()) const;
    void scanRootPath();
    void parseToc(const QString &fileName);
    void parseIndex(const QString &fileName);

    QString replaceFileExtension(const QString &fileName,
            const QString &extension);
    QString getTocFileName(const QString &projectFileName);
    QString getIndexFileName(const QString &projectFileName);
    QString getRootPath(const QString &projectFileName);

private:
    QString namespaceName() const;
    QString virtualFolder() const;
    QList<QHelpDataCustomFilter> customFilters() const;
    QList<QHelpDataFilterSection> filterSections() const;
    QMap<QString, QVariant> metaData() const;
    QString rootPath() const;

};

QT_END_NAMESPACE

#endif // HTMLHELPDATAINTERFACE_P_H

